// WinInetRequestTest.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"

#include <windows.h>
#include <Wininet.h>

#include <assert.h>
#include <string>
#include <sstream>
#include <locale.h>
#include <conio.h>
#include "NhConversion.h"

#pragma comment( lib, "Wininet.lib" )

typedef std::basic_string<TCHAR>		tstring;
typedef std::basic_stringstream<TCHAR>	tstringstream;

#define URLBUFFER_SIZE		(4096)
#define	READBUFFER_SIZE		(4096)

bool HttpRequest(	tstring strUserAgent,
					tstring strUrl,
					bool bIsHttpVerbGet,
					tstring strParameter,
					tstring& rstrResult )
{
	// AEgvbg̏
	rstrResult = tstring();

	// Cvbg̃`FbN
	if( 0 == strUrl.length() )
	{
		assert( !"URLs" );
		return false;
	}

	// ϐ
	HINTERNET			hInternetOpen = NULL;
	HINTERNET			hInternetConnect = NULL;
	HINTERNET			hInternetRequest = NULL;
	char*				pszOptional = NULL;
	URL_COMPONENTS		urlcomponents;
	tstring				strServer;
	tstring				strObject;
	INTERNET_PORT		nPort;
	tstring				strVerb;
	tstring				strHeaders;
	tstringstream		ssRead;

	// URL
	ZeroMemory( &urlcomponents, sizeof(URL_COMPONENTS) );
	urlcomponents.dwStructSize = sizeof(URL_COMPONENTS);
	TCHAR szHostName[URLBUFFER_SIZE];
	TCHAR szUrlPath[URLBUFFER_SIZE];
	urlcomponents.lpszHostName	= szHostName;
	urlcomponents.lpszUrlPath	= szUrlPath;
	urlcomponents.dwHostNameLength	= URLBUFFER_SIZE;
	urlcomponents.dwUrlPathLength	= URLBUFFER_SIZE;
	if( !InternetCrackUrl(	strUrl.c_str(),
							(DWORD)strUrl.length(),
							0,
							&urlcomponents ) )
	{	// URL̉͂Ɏs
		assert( !"URL͂Ɏs" );
		return false;
	}
	strServer = urlcomponents.lpszHostName;
	strObject = urlcomponents.lpszUrlPath;
	nPort	  = urlcomponents.nPort;

	// HTTPHTTPSȊO
	DWORD dwFlags = 0;
	if(		 INTERNET_SCHEME_HTTP == urlcomponents.nScheme )
	{	// HTTP
		dwFlags = INTERNET_FLAG_RELOAD				// vꂽt@CAIuWFNgA܂̓tH_ꗗALbVł͂ȂÃT[o[狭IɃ_E[h܂B
				| INTERNET_FLAG_DONT_CACHE			// ԂꂽGeBeBLV֒ǉ܂B
				| INTERNET_FLAG_NO_AUTO_REDIRECT;	// HTTP ŎgpA_CNg HttpSendRequest ŏȂƂw肵܂B
	}
	else if( INTERNET_SCHEME_HTTPS == urlcomponents.nScheme )
	{	// HTTPS
		dwFlags = INTERNET_FLAG_RELOAD				// vꂽt@CAIuWFNgA܂̓tH_ꗗALbVł͂ȂÃT[o[狭IɃ_E[h܂B
				| INTERNET_FLAG_DONT_CACHE			// ԂꂽGeBeBLV֒ǉ܂B
				| INTERNET_FLAG_NO_AUTO_REDIRECT	// HTTP ŎgpA_CNg HttpSendRequest ŏȂƂw肵܂B
				| INTERNET_FLAG_SECURE						// SȃgUNVgp܂BɂASSL/PCT g悤ɕϊAHTTP vŗLłB 
				| INTERNET_FLAG_IGNORE_CERT_DATE_INVALID	// INTERNET_FLAG_IGNORE_CERT_DATE_INVALIDAINTERNET_FLAG_IGNORE_CERT_CN_INVALID
				| INTERNET_FLAG_IGNORE_CERT_CN_INVALID;		// ́AؖɊւx𖳎tO
	}
	else
	{
		assert( !"HTTPłHTTPSłȂ" );
		return false;
	}

	// GETPOST
	if( bIsHttpVerbGet )
	{	// GET
		strVerb		= _T("GET");
		strHeaders	= _T("");
		if( 0 != strParameter.length() )
		{	// IuWFNgƃp[^u?vŘA
			strObject += _T("?") + strParameter;
		}
	}
	else
	{	// POST
		strVerb		= _T("POST");
		strHeaders	= _T("Content-Type: application/x-www-form-urlencoded");
		if( 0 != strParameter.length() )
		{	// p[^AMIvVf[^ɕϊ
			pszOptional = NhT2M( strParameter.c_str() );	// charɕϊ
		}
	}

	// WinInet̏
	hInternetOpen = InternetOpen(	strUserAgent.c_str(),
									INTERNET_OPEN_TYPE_PRECONFIG,
									NULL, NULL, 0 );
	if( NULL == hInternetOpen )
	{
		assert( !"WinInet̏Ɏs" );
		goto LABEL_ERROR;
	}

	// HTTPڑ
	hInternetConnect = InternetConnect(	hInternetOpen,
										strServer.c_str(),
										nPort,
										NULL,
										NULL,
										INTERNET_SERVICE_HTTP,
										0,
										0 );
	if( NULL == hInternetConnect )
	{
		assert( !"HTTPڑɎs" );
		goto LABEL_ERROR;
	}

	// HTTPڑJ
	hInternetRequest = HttpOpenRequest( hInternetConnect,
										strVerb.c_str(),
										strObject.c_str(),
										NULL,
										NULL,
										NULL,
										dwFlags,
										NULL );
	if( NULL == hInternetRequest )
	{
		assert( !"HTTPڑJɎs" );
		goto LABEL_ERROR;
	}

	// HTTPvM
	if( !HttpSendRequest(	hInternetRequest,
							strHeaders.c_str(),
							(DWORD)strHeaders.length(),
							(LPVOID)((char*)pszOptional),
							pszOptional ? (DWORD)(strlen(pszOptional) * sizeof(char)) : 0 ) )
	{
		assert( !"HTTPvMɎs" );
		goto LABEL_ERROR;
	}

	// HTTPvɑΉXe[^XR[h̎擾
	DWORD dwStatusCode;
	DWORD dwLength = sizeof(DWORD);
	if( !HttpQueryInfo(	hInternetRequest,
						HTTP_QUERY_STATUS_CODE | HTTP_QUERY_FLAG_NUMBER,
						&dwStatusCode,
						&dwLength,
						0 ) )
	{
		assert( !"HTTPvɑΉXe[^XR[h̎擾Ɏs" );
		goto LABEL_ERROR;
	}
	if( HTTP_STATUS_OK != dwStatusCode )
	{
		assert( !"Xe[^XR[hOKłȂ" );
		goto LABEL_ERROR;
	}

	// HTTPt@Cǂݍ
	char szReadBuffer[READBUFFER_SIZE + 1];
	while( 1 )
	{
		DWORD dwRead = 0;
		if( !InternetReadFile( hInternetRequest, szReadBuffer, READBUFFER_SIZE, &dwRead ) )
		{
			assert( !"HTTPt@Cǂݍ݂Ɏs" );
			goto LABEL_ERROR;
		}
		if( 0 == dwRead )
		{
			break;
		}
		szReadBuffer[dwRead] = '\0';	// I[u\0v̕t
		size_t length = dwRead + 1;
		LPWSTR	pszWideChar = (LPWSTR)malloc( length * sizeof(WCHAR) );
		MultiByteToWideChar(	CP_UTF8,	// CODE PAGE: UTF-8
								0,
								szReadBuffer,
								-1,
								pszWideChar,
								(int)length );	// UTF-8ANSIɕϊ
		TCHAR* pszTchar = NhW2T( pszWideChar );	// WideCharTCHARɕϊ
		ssRead << pszTchar;	// Xg[ɗ
		free( pszTchar );
		free( pszWideChar );
	}

	// Xg[Ao͕ɕϊ
	rstrResult = ssRead.str().c_str();

	if( pszOptional ){ free( pszOptional ); }
	InternetCloseHandle(hInternetRequest);
	InternetCloseHandle(hInternetConnect);
	InternetCloseHandle(hInternetOpen);
	return true;

LABEL_ERROR:
	if( pszOptional ){ free( pszOptional ); }
	InternetCloseHandle(hInternetRequest);
	InternetCloseHandle(hInternetConnect);
	InternetCloseHandle(hInternetOpen);
	return false;
}

int _tmain(int argc, _TCHAR* argv[])
{
	tstring strUserAgent	= _T("HttpRequestTest");
	tstring strUrl			= _T("http://weather.livedoor.com/forecast/webservice/json/v1");
	bool bIsHttpVerbGet		= true;
	tstring strParameter	= _T("city=400040");

	tstring strResult;
	if( !HttpRequest(	strUserAgent,
						strUrl,
						bIsHttpVerbGet,
						strParameter,
						strResult ) )
	{
		return false;
	}

	setlocale( LC_ALL, "Japanese" ); 
	_tprintf( _T("%s"), strResult.c_str() );

	_getch();

	return 0;
}
